config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: { registrations: "registrations", :passwords => "passwords" }
  root 'pages#home'
  get 'admin/confirm' => 'admin#confirm'
  get 'admin/unlock' => 'admin#unlock'
  resources :admin
  #get 'admin' => 'admin#index'
  #get 'admin/edit' => 'admin#edit'
  #patch 'admin/edit' => 'admin#update'
  #delete 'admin/edit' => 'admin#destroy'
  
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable,
         :confirmable, :lockable, :timeoutable

  extend FriendlyId
  friendly_id :username, use: :slugged
  mount_uploader :avatar, AvatarUploader

  validates_uniqueness_of :username
  validates_presence_of :username
  validates :username, length: { in: 4..20 }
  attr_accessor :login
  validate :validate_username

  def validate_username
    if User.where(email: username).exists?
      errors.add(:username, :invalid)
    end
  end

  def gravatar_id
  	Digest::MD5::hexdigest(email.downcase)
  end

  def self.find_first_by_auth_conditions(warden_conditions)
    conditions = warden_conditions.dup
    if login = conditions.delete(:login)
      where(conditions).where(["lower(username) = :value OR lower(email) = :value", { :value => login.downcase }]).first
    else
      if conditions[:email].nil?
        where(conditions).first
      else
        where(email: conditions[:email]).first
    end
    end
  end

end

app/controllers/admin_controller.rb
# frozen_string_literal: true

class AdminController < ApplicationController
  before_action :authenticate_user!
  before_action :authenticate_admin
  skip_before_action :verify_authenticity_token, only: [:update], if: -> { params[:avatar] }

  def index
    @users = User.all
  end

  def edit
    @user = User.find(params[:id])
    respond_to do |format|
      format.html { render :edit }
      format.js { render :edit }
    end
  end

  def update
    @user = User.find(params[:id])
    @user.slug = nil
    if @user.update_without_password(user_params)
      if params[:user][:password]
        @user.password = params[:user][:password]
        @user.password_confirmation = params[:user][:password_confirmation]
        @user.reset_password_token = 'temp'
        @user.save
      end
      redirect_to admin_index_path
    else
      render :edit
    end
  end

  def destroy
    @user = User.find(params[:id])
    @user.destroy
    flash[:success] = 'Account deleted!'
    redirect_to admin_index_path
  end

  def confirm
    user = User.find(params[:id])
    user.confirmed_at = Date.today
    user.save!
    flash[:success] = 'User confirmed'
    redirect_to admin_index_path
  end

  def unlock
    user = User.find(params[:id])
    user.unlock_access!
    flash[:success] = 'User unlocked'
    redirect_to admin_index_path
  end

  private

  def user_params
    params.require(:user).permit(:username, :email, :password, :password_confirmation, :admin, :avatar)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up) do |u|
      u.permit(:username, :email, :password, :password_confirmation)
    end
    devise_parameter_sanitizer.permit(:sign_in) do |u|
      u.permit(:login, :username, :email, :password, :remember_me)
    end
    devise_parameter_sanitizer.permit(:account_update) do |u|
      u.permit(:username, :email, :password, :password_confirmation, :current_password, :avatar)
    end
  end

  def authenticate_admin
    unless current_user.try(:admin?)
      redirect_to root_path
    end
  end

end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  
end

app/controllers/passwords_controller.rb
class PasswordsController < Devise::PasswordsController
  protected
  def after_sending_reset_password_instructions_path_for(resource_name)
    flash[:success] = 'Email sent for password reset'
    root_path
  end
end

app/controllers/registrations_controller.rb
class RegistrationsController < Devise::RegistrationsController
  protected

  def after_inactive_sign_up_path_for(resource)
    signed_in_root_path(resource)
  end

  def after_update_path_for(resource)
    resource.slug = nil
    resource.save!
    root_path
  end

  def update_resource(resource, params)
    # Require current password if user is trying to change password.
    return super if params['password']&.present?

    # Allows user to update registration information without password.
    resource.update_without_password(params.except('current_password'))
  end
end

app/helpers/admin_helper.rb
module AdminHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/users_helper.rb
module UsersHelper
  def profile_image_for(user, options = {})
    size = options[:size] || 80
    imgclass = options[:class] || 'gravatar'
    if user.avatar?
      image_tag(user.avatar.thumb.url, alt: user.email, class: imgclass, size: size)
    else
      url = "https://secure.gravatar.com/avatar/#{user.gravatar_id}?s=#{size}&d=identicon"
      image_tag(url, alt: user.email, class: imgclass)
    end
  end
end

app/views/admin/_index.html.haml
.main-index
  .container
    .row
      .col-sm-1
      .col-sm-10
        .card
          .card-header
            .font-weight-bold All Users
          .card-body
            - @users.each do |user|
              .row
                .col-sm-3
                  = user.username
                .col-sm-6
                  = user.email
                .col-sm-3
                  = link_to 'Edit', edit_admin_path(user.id), remote: true
                  |
                  = link_to 'Destroy', admin_path(user.id), method: :delete, data: { confirm: 'Are you sure?' }
                %hr
      .col-sm-1

app/views/admin/_useredit.html.haml
= bootstrap_form_for @user, url: admin_path(@user.id), remote: true do |f|
  .row
    .col-sm-3
      = profile_image_for(@user)
    .col-sm-9
      = f.file_field :avatar, class: "filestyle", :"data-placeholder" => "No file"
  %fieldset
    .form-group
      .row
        .col-sm-12
          = f.text_field :username, icon: "user", hide_label: true, placeholder: "User Name", value: @user.username
      .row
        .col-sm-12
          = f.email_field :email, icon: "envelope", hide_label: true, placeholder: "Email Address", value: @user.email
      .row
        .col-sm-12
          = f.password_field :password, icon: "asterisk", hide_label: true, placeholder: "New Password"
      .row
        .col-sm-12
          = f.password_field :password_confirmation, hide_label: true, icon: "asterisk", placeholder: "New Password again"
      - if current_user.try(:admin?)
        .row
          .col-sm-12
            - if @user.admin?
              = f.check_box :admin, {checked: true}
            - else
              = f.check_box :admin
      = f.submit "Update", class: "btn btn-outline-secondary"
      - unless @user.locked_at.nil?
        = link_to 'Unlock', admin_unlock_path(:id => @user.id), class: "btn btn-outline-secondary"
      - if @user.confirmed_at.nil?
        = link_to 'Confirm', admin_confirm_path(:id => @user.id), class: "btn btn-outline-secondary"

app/views/admin/edit.js.haml
$("#WidgetGenModalBody").html('#{escape_javascript render(partial: "useredit")}')
if($('#WidgetGenModal').is(':hidden')) {
$("#WidgetGenModal").modal("toggle")
}

app/views/admin/index.html.haml
%br/
= render 'index'

app/views/admin/index.js.haml
$(".main-index").html('#{escape_javascript render("index")}')
$("#WidgetGenModal").modal("toggle")
toastr["success"]("user updated");

app/views/layouts/_modal.html.haml
#WidgetGenModal.modal.fade{"aria-hidden" => "true", "aria-labelledby" => "widgetGenModal", :role => "dialog", :tabindex => "-1"}
  .modal-dialog
    .modal-content
      #WidgetGenModalBody.modal-body
      .modal-footer
        #test
        
        #output
        .clearfix.visible-xs
        %button.btn.btn-default{"data-dismiss" => "modal", :type => "button"} Close
    / /.modal-content
  / /.modal-dialog
/ /.modal

app/views/layouts/_navbar.html.haml
%nav.navbar.navbar-dark.bg-dark.sticky-top.navbar-expand-sm.py-0
  .container
    %button.navbar-toggler{"aria-controls" => "navbarNav", "aria-expanded" => "false", "aria-label" => "Toggle navigation", "data-target" => "#navbar", "data-toggle" => "collapse", :type => "button"}
      %span.navbar-toggler-icon

    = link_to "Project Name", root_path, class: "navbar-brand"
    #navbar.navbar-collapse.collapse
      %br
      - if current_user
        %ul.navbar-nav.ml-auto
          %li.dropdown
            %a.nav-link.dropdown-toggle{"aria-expanded" => "false", "aria-haspopup" => "true", "data-toggle" => "dropdown", :href => "#", :role => "button"}
              = profile_image_for(current_user, size: 30) + current_user.username
              %span.caret
            .dropdown-menu
              - if current_user.try(:admin?)
                = link_to '<i class="fas fa-tachometer-alt" aria-hidden="true"></i> Admin Dash'.html_safe, admin_index_path, class: "dropdown-item"
              = link_to '<i class="fas fa-pencil-alt" aria-hidden="true"></i> Edit'.html_safe, edit_user_registration_path(current_user), class: "dropdown-item"
              .dropdown-divider{:role => "separator"}
              = link_to '<i class="fas fa-sign-out-alt" aria-hidden="true"></i> Sign Out'.html_safe, destroy_user_session_path, :method => :delete, class: "dropdown-item"
      - else
        = link_to "Sign In", new_user_session_path, class: "btn btn-sm align-middle btn-primary ml-auto btn-margin-left btn-margin-right"
        = link_to "Sign Up", new_user_registration_path, class: "btn btn-sm align-middle btn-primary btn-margin-left"
      .pad-bottom

app/views/layouts/_toastr.html.haml
- flash.keys.each do |key|
  - toastr_key = key
  - toastr_key = 'info' if key == 'notice'
  - toastr_key = 'warning' if key == 'alert'
  :javascript
    toastr["#{toastr_key}"]("#{flash[key]}",);

app/views/layouts/application.html.haml
!!!
%html
  %head
    %title StarterBootstrap  
    = stylesheet_pack_tag 'application', 'data-turbolinks-track': 'reload'
    = javascript_pack_tag 'application', 'data-turbolinks-track': 'reload'
    %meta{:content => "width=device-width, initial-scale=1.0", :name => "viewport"}/
    = csrf_meta_tags
  %body
    = render 'layouts/navbar'
    = render 'layouts/toastr'
    = yield


    #reusable_modal.modal.fade{:role => "dialog", :tabindex => "-1"}
      .modal-dialog
        .modal-content
          / this is where the content will be placed by the script

    = render 'layouts/modal'
          
    .container
      %hr
        %footer
          %p 
            = "&copy; Company #{Time.current.year}".html_safe

app/views/layouts/notify.js.haml
if($('#WidgetGenModal').is(':visible')) {
$("#WidgetGenModal").modal("toggle")
}
toastr["info"]("#{message}");

app/views/pages/home.html.haml
/ Main jumbotron for a primary marketing message or call to action
.jumbotron
  .container
    %h1 Hello, world!
    %p This is a template for a simple marketing or informational website. It includes a large callout called a jumbotron and three supporting pieces of content. Use it as a starting point to create something more unique.
    %p
      %a.btn.btn-primary.btn-lg{:href => "#", :role => "button"} Learn more &raquo;
.container
  / Example row of columns
  .row
    .col-md-4
      %h2 Heading
      %p Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Etiam porta sem malesuada magna mollis euismod. Donec sed odio dui.
      %p
        %a.btn.btn-outline-secondary{:href => "#", :role => "button"} View details &raquo;
    .col-md-4
      %h2 Heading
      %p Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Etiam porta sem malesuada magna mollis euismod. Donec sed odio dui.
      %p
        %a.btn.btn-outline-secondary{:href => "#", :role => "button"} View details &raquo;
    .col-md-4
      %h2 Heading
      %p Donec sed odio dui. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Vestibulum id ligula porta felis euismod semper. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.
      %p
        %a.btn.btn-outline-secondary{:href => "#", :role => "button"} View details &raquo;

app/views/users/shared/_links.html.haml
- if controller_name != 'sessions'
  = link_to "Log in", new_session_path(resource_name)
  %br

- if devise_mapping.registerable? && controller_name != 'registrations'
  = link_to "Sign up", new_registration_path(resource_name)
  %br

- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations'
  = link_to "Forgot your password?", new_password_path(resource_name)
  %br

- if devise_mapping.confirmable? && controller_name != 'confirmations'
  = link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name)
  %br

- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks'
  = link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name)
  %br

- if devise_mapping.omniauthable?
  - resource_class.omniauth_providers.each do |provider|
    = link_to "Sign in with #{provider.to_s.titleize}", omniauth_authorize_path(resource_name, provider)
    %br